import Foundation
class Drink {
    
    func orderDrink(_ drink: String) {
        return print("You ordered \(drink)")
    }
}

let drink = Drink()
drink.orderDrink("Cola")

extension Drink {
    func payDrink(_ price: Double) {
        return print("You have to pay \(price)")
    }
}

drink.payDrink(7.99)

extension String {
    func isValidEmail() -> Bool {
        let emailRegex = "[A-Z0-9a-z._%+-]+@[A-Z0-9a-z.-]+\\.[A-Za-z]{2,64}"
        let emailTest = NSPredicate(format: "SELF MATCHES %@", emailRegex)
        return emailTest.evaluate(with: self)
    }
}

let email = "johan@exodai.academy"
print(email.isValidEmail())

struct Point {
    var x: Double, y: Double
}

extension Point {
    var isOrigin: Bool {
        return x == 0 && y == 0
    }
}

let p = Point(x: 0, y: 0)
print(p.isOrigin)


// User.swift
// User+create.swift
// User+update.swift

// PRotocols

protocol WorkOuts {
    func lunges(_ amount: Int) -> String
}

protocol Identifiable {
    var ID: String {get set}
    
    func display()
}
//
//struct User: Identifiable {
//    var ID: String
//}
//
//struct Videos: Identifiable {
//    var ID: String
//}

protocol MakeShake {
    associatedtype fluid
    associatedtype fruit
    associatedtype sweetener
    
    func makeShake(_ fluid: fluid, _ fruit: fruit, _ sweetener: sweetener)
}

struct Fluids {
    var milk: String
}

struct Fruit {
    var Berry: String
}

struct Sweetener {
    var sugar: String
}
class BerryMilkshake: MakeShake {
    typealias fluid = Fluids
    typealias fruit = Fruit
    typealias sweetener = Sweetener
    
    func makeShake(_ fluid: Fluids, _ fruit: Fruit, _ sweetener: Sweetener) {
        <#code#>
    }
}

extension Identifiable {
    func display() {
        print(ID)
    }
}

struct Employee: Identifiable {
    var ID: String
}

let emp = Employee(ID: "ID123456")
emp.display()


// Function

func sayHello() {
    
}

struct MyStaticFunctions {
    static func sayHello() {
        print("Hello")
    }
}

MyStaticFunctions.sayHello()

struct PrivateFunctions {
    private func dontSayHello() {
        print("Im not going to say heloo tooo you")
    }
    
    func usePrivateFunction() {
        dontSayHello()
    }
}

let privatefunctions = PrivateFunctions()
privatefunctions.usePrivateFunction()

@objc class Rectangle: NSObject {
    @objc func calculateRectangle(width: Double, height: Double) -> Double {
        return width * height
    }
}
let rectangle = Rectangle()
let width = 10.0
let height = 20.0
let area = rectangle.calculateRectangle(width: width, height: height)
print(area)

// Actors

actor ArticleCounter {
    private var views: [String: Int] = [:]
    
    func incrementViews(for article: String) {
        views[article, default: 0] += 1
    }
    
    func views(for article: String) -> Int {
        return views[article, default: 0]
    }
}

let counter = ArticleCounter()

//Task {
//    await counter.incrementViews(for: "Actors in Swift")
//    let viewCount = await counter.views(for: "Actors in Swift")
//    print(viewCount)
//}

// Initializers

class Product {
    var name: String
    var quantity: Int
    var price: Double
    
    // Designated Initializer
    init(name: String, quantity: Int, price: Double) {
        self.name = name
        self.quantity = quantity
        self.price = price
    }
    
        // Convenience Initialiser
    convenience init() {
        self.init(name: "Unknown", quantity: 0, price: 0.0)
    }
}

let defaultProduct = Product()
let specificProduct = Product(name: "Mac Mini", quantity: 50, price: 999.99)

struct Pixel {
    var x: Double
    var y: Double
}

let pixel = Pixel(x: 10.0, y: 10.0)

class Document {
    var name: String?
    
    // Failable Initializer
    init?(name: String) {
        if name.isEmpty {return nil}
        self.name = name
    }
}


class Vehicle {
    var wheels: Int
    init(wheels: Int) {
        self.wheels = wheels
    }
}

class Car: Vehicle {
    var brand: String
    init(brand: String) {
        self.brand = brand
        super.init(wheels: 4)
    }
}

let tesla = Car(brand: "Tesla")
print(tesla.brand)
print(tesla.wheels)

// Deinitializers

class Player {
    static var activePlayers = 0
    
    init() {
        Player.activePlayers += 1
    }
    
    deinit {
        Player.activePlayers -= 1
    }
}

class FileHandle {
    let descriptor: Int
    
    init(_ descriptor: Int) {
        self.descriptor = descriptor
        print(descriptor)
    }
    
    deinit {
        print("file is closed \(descriptor)")
    }
}

func createFile() {
 let file = FileHandle(103)
    // Is initialized
    // Desinitializer is called
}

createFile()

class BaseClass {
    init() {
        print("Initialized")
    }
    
    deinit {
        print("Deinitialized")
    }
}

class Subclass: BaseClass {
    override init() {
        print("Subclass Initialized")
    }
    
    deinit {
        print("Subclass Deinitalized")
    }
}

func createInstance() {
    let instance = Subclass()
}

createInstance()

// Optional Chaining

class Department {
    var head: Head?
    var name: String
    
    weak var manager: Staff?
    
    init(name: String) {
        self.name = name
    }
}

class Head {
    var officeNumber: String?
}

//let department = Department()
//
//let officeNumber = department.head?.officeNumber

class Worker {
    var jobtitle: String?
    
    func logJobTitle() {
        print("job title = \(jobtitle ?? "Unknown")")
    }
}

let worker: Worker? = Worker()
worker?.jobtitle = "CEO"
worker?.logJobTitle()
    
struct Task {
    var description: String?
}

class Project {
    var currentTask: Task?
    
    func getTaskDescription() -> String? {
        return currentTask?.description
    }
}

let project = Project()

//project.currentTask = Task(description: "Teaching you how to code")

if let taskDescription = project.getTaskDescription() {
    print(taskDescription)
} else {
    print("No current tasks present")
}

// Advanced Operators

// AND Operator

var newPassword: String = "Pokemon12"
var verifyNewPassword: String = "Pokemon12"

if newPassword == verifyNewPassword && newPassword.count == 12 {
 print("Password is fine")
} else {
    print("Password is not fine")
}

// OR Operator

let connection = false
let localData = false

if connection || localData {
    print("Keep working")
} else {
    print("Functionality is limited")
}

class Person {
    var name: String
    
    init(name: String) {
        self.name = name
    }
    
    deinit {
        
    }
}

var reference1: Person?
var reference2: Person?
var reference3: Person?

reference1 = Person(name: "Johan") // JOhan being initialized
reference2 = Person(name: "Mark")
reference3 = Person(name: "Adaja")

reference1 = nil
reference2 = nil
reference3 = nil

class Staff {
    let name: String?
    var department: Department?
    
    init(name: String?) {
        self.name = name
    }
    
    deinit {}
}

var john: Staff? = Staff(name: "John")
var hr: Department? = Department(name: "HR")

john!.department = hr
hr!.manager = john

john = nil
hr = nil

// Opaque Types

protocol Shape {
    func draw() -> String
}

struct Circle: Shape {
    func draw() -> String {
        return "Drawing a 2 circles"
    }
}

struct Pyramid: Shape {
    func draw() -> String {
        return "Drawing a Pyramid"
    }
}

func createShape() -> some Shape {
    return Circle()
}

// Subscripts

struct Days {
    private var days = ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday"]
    
    subscript(index: Int) -> String {
        get {
            // Returns a value
            return days[index]
        }
        set(newValue) {
            // Set a new Value
            days[index] = newValue
        }
    }
}

var week = Days()
print(week[0])

week[5] = "Fun Day"
print(week[5])

struct Matrix {
    var data: [[Int]]
    subscript(row: Int, column: Int) -> Int {
        get {
            return data[row][column]
        }
        set {
            data[row][column] = newValue
        }
    }
}

var matrix = Matrix(data: [[1, 2], [3, 4]])
print(matrix[0, 1])
matrix[0, 1] = 20
print(matrix[0, 1])

// Type Casting

class Book {
    var name: String
    init(name: String) {
        self.name = name
    }
}

class Magazine: Book {
    func showName() {
        print("\(name) is a Magazine")
    }
}

class CookBook: Book {
    func showName() {
        print("\(name) is a Cook Book")
    }
}

let books: [Book] = [Magazine(name: "Vogue"), CookBook(name: "Jamie Oliver Italian")]

for bo in books {
    if let book = bo as? Magazine {
        book.showName()
    } else if let cookBook = bo as? CookBook {
        cookBook.showName()
    }
}

// Concurrency

func fetchInformation(_ url: URL) async throws -> Data {
    let (data, _) = try await URLSession.shared.data(from: url)
    return data
}

func processImageData() async {
    let url = URL(string: "https://exodai.academy/image.png")!
    do {
        let data = try await fetchInformation(url)
        // processing the data
        print("Data is fetched and processed successfully")
    } catch {
        print("Error fething information \(error)")
    }
}

var newCounter = 0

let que = DispatchQueue(label: "com.example.que")

func incrementCounter() {
    for _ in 0..<1000 {
        newCounter += 1
    }
}

que.async {
    incrementCounter()
}

que.async {
    incrementCounter()
}

DispatchQueue.main.asyncAfter(deadline: .now() + 1) {
        print("Final Counter Value \(newCounter)")
}
